%function [lset,xco,yco,status_set,C,knotloc_moved,Cvel_basis,knotloc_old] = systemsample(lset,xco,yco,status_set,C,knotloc_moved,Cvel_basis,knotloc_old)
function [levset,state,levsetIS,stateIS] =  mcsystemsample2(levset,state,knotloc_old,t,Yt)
global n M order
global K K0
global alpha
global Sigma0 A a atrans Signoise signoise deform translate signoise_trans Sigma0_trans Signoise_trans deform tdim
global u0 v0 sig2obs
global sz

global zerolength changetopo atbndry setzero
global impsampling impsampiters
global dmin2 dmax2 dopt knotschange toofewknots
global nomarkov
global bias biasvec deformindx bias0
global dispsamps
global changetopom atbndrym zerolengthm deformindxmt useKtsim
global thetaknots

if (nomarkov)
    at = 0;    atranst = 0;
else
    at = a;    atranst = atrans;
end

for m = 1:M
    for i = 1:n
        [lset,xco,yco,status_set] = getlevset(levset(i,m));
        [C,knotloc_moved, Cvel_basis] = getstate(state(i,m));
        Signoise = signoise * eye(K);
        if (tdim==2)
            Signoise_trans = diag(signoise_trans(5:6));
        else
            Signoise_trans = diag(signoise_trans);
        end
        A = at * eye(K);
        Atrans = atranst * eye(tdim);

        if (translate)
            [C,knotloc_moved,Cvel_basis,Ctrans] = getstate(state(i,m));
            Ctrans = Atrans * Ctrans + diag(sqrt(Signoise_trans)).*randn(tdim,1);
            if (tdim==2)
                vec = [ 0 0 0 0 Ctrans(1) Ctrans(2)];        % disp('large Ctrans causes large lset motion - resulting in changetopo')
            else
                vec0 = Ctrans';
                vec = vec0; 
                %vec(2:3) = 0; %vec(4) = vec0(1);  %vec(2:4) = 0; %only x and y scaling non-zero
            end
            [lset,xco,yco,status_set,C,origin,zeroset] = affinetfm_geom(levset(i,m),vec);
            pmat = [vec(1), vec(2); vec(3), vec(4)];
            trans = [vec(5);vec(6)];
            % knotloc_moved = knotloc_moved +trans*ones(1,K) + pmat*(knotloc_moved);%WRONG: -origin*ones(1,K)
            getcontour_geom % needed to get nz for Find_Narrow_Band         
        else
            Ctrans = zeros(tdim,1);
        end

        biasvec = zeros(K,1); biasvec(deformindx)=1;     %deformindx = find(sum(knotloc_moved > (sz'/2 - 10)*ones(1,K))==2);% find knots lying in fourth quadrant of image
        % correct this: works only if K, K0 close to each other: need to add/remove one point at a time as in ICASSP2
        if (K~=K0)&(~useKtsim)
            d2= mod(deformindx * K/K0 - 0.01, K);
            deformindx2 = [floor(d2)+(~floor(d2))*K, ceil(d2)]; %if floor(d2)==0: set it to 8
            biasvec = zeros(K,1); biasvec(deformindx2)=1;
        else
            d2 = deformindx;
        end
        if (n>1)
            Signoise = Signoise + diag(biasvec)*(bias0^2)* (2^2) ;
            %Signoise = Signoise + eye(K)*bias0^2 *2^2: DOESN'T WORK SOMETIMES
        end
        if (n==1) %simulating the sequence
            Cvel_basis = A* Cvel_basis + diag(sqrt(Signoise)).* randn(K,1) + bias*biasvec;  %Markov velocities
        else
            Cvel_basis = A* Cvel_basis + diag(sqrt(Signoise)).* randn(K,1) ;
        end

        % moving the contour by interpolated velocity Cvel_basis: need a set of iterations bcoz need to satisfy CFL condition when moving level set
        if (deform)
            maxvel = max(abs(Cvel_basis(:)));
            totiter = max( 1 , ceil(maxvel/(2-alpha)) );
            Cdot_basis = Cvel_basis/totiter;
            for iter = 1:totiter
                detectbndry
%                Cc = C - mean(C,2)*ones(1,length(C));
%                ang = atan2(Cc(2,:),Cc(1,:)) ;
                disp('weird lookin gradient of lset, something wrong, not working');
                [grad_lsety,grad_lsetx] = gradient(lset); %grad_lsety,x : following Yogesh's convention
                glx = grad_lsetx(zeroset); gly = grad_lsety(zeroset);
                ang = atan2(gly,glx);
                thetaCc = ang + (ang<0)*2*pi;
                [B] = get_basis_fns_theta(thetaCc,thetaknots,K);
                Cdot_basis_full(1:K,1) = Cdot_basis;
                Cdot_basis_full(K+1:K+order-1,1) = Cdot_basis(1:order-1);
                Cvel = B*Cdot_basis_full;
%                Cvel_NB=extend2(C,Cvel,lset,xco,yco);
                mask = zeros(size(lset)); mask(zeroset)=1;
                sdist_zeroset = lset.*mask;
                [sdist,extensionvel_region] = FastMarching(sdist_zeroset,Cvel,6*nz);
                [lset,dt_Cvel] = move_NB(Cvel_NB,lset,xco,yco,status_set,alpha,0);
                getcontour_geom % needed to get nz for Find_Narrow_Band
                [xco,yco,zeroset,xc,yc,lset,status_set,nbset] = Find_Narrow_band(lset,status_set,xco,yco,1,6*nz); %Later set expand = 0 (last input variable above)
            end   %for iter
        end % if (deform)
        state(i,m) = struct('C',C, 'Cvel_basis',Cvel_basis, 'Ctrans', Ctrans,'knotloc_moved',knotloc_moved);
        levset(i,m) = struct('lset',lset, 'xco',xco, 'yco',yco, 'status_set',status_set);

        if impsampling        %impsampiters = 0;   u(1:n)=u0; v(1:n)=v0;
            for iter = 1:impsampiters
                %detectchangetopo,  
                detectbndry   %getcontour_geom
                img = Yt{t};
                [region_term,u,v] = get_velocity_chanvese(img,lset,xco,yco);
                [extend_this,sdist] = extend_initialize(lset,xco,yco,region_term);
                [sdist,extensionvel_region] = FastMarching(sdist,extend_this,6*nz);
                alpha0=alpha; alpha = 0.2;     %weight for smoothing contour
                %                 [edge_term] = get_velocity_edge(img,lset,xco,yco);
                %                 [extend_this,sdist] = extend_initialize(lset,xco,yco,edge_term);
                %                 [sdist,extensionvel_edge] = FastMarching(sdist,extend_this,6*nz);
                %                 [lset,dt_Cvel] = move_NB(extensionvel_region,lset,xco,yco,status_set,alpha,1,extensionvel_edge);
                [lset,dt_Cvel] = move_NB(extensionvel_region,lset,xco,yco,status_set,alpha,1);
                alpha = alpha0;
                getcontour_geom % needed to get nz for Find_Narrow_Band
                [xco,yco,zeroset,xc,yc,lset,status_set,nbset] = Find_Narrow_band(lset,status_set,xco,yco,1,6*nz); %Later set expand = 0 (last input variable above)
            end
            stateIS(i,m) = struct('C',C, 'Cvel_basis',Cvel_basis, 'Ctrans', Ctrans,'knotloc_moved',knotloc_moved);
            levsetIS(i,m) = struct('lset',lset, 'xco',xco, 'yco',yco, 'status_set',status_set);
        end
%        deformindxmt(i,m,t) = d2;
    end %for i=1:n
  %  changetopom(1:n,m) = changetopo(:);
    atbndrym(1:n,m) = atbndry(:);
   % zerolengthm(1:n,m) = zerolength(:);
end %for m=1:M
