sim = 1 %to generate simulated data and track it. set sim = 0 to display the tracking results
T = 9, totitern = 50

if sim
    datestr(now),
    randn('state',0), rand('state',0)

    for itern = 1: totitern
        translate = 1; tdim = 2; deform = 1;
        gendata_2obj_geom
        state_sim = state; levset_sim = levset;  state2_sim = state;
        save(['../deformstats/tmp_gendata_change_iter',num2str(itern)])
        clear all,
        T = 9, totitern = 50
    end
    disp('done generating data')
    
    T = 9, totitern = 50
    for itern = 1: totitern
        load(['../deformstats/tmp_gendata_change_iter',num2str(itern)])
        translate = 1; tdim = 2; deform = 1; %parameters to select to run deform pf-mt
        mcpf2_geom                           % runs either deform or affine pf-mt
        state_def = stateIS; weights_def = prodweightold;
        save(['../deformstats/tmp_def_change_iter',num2str(itern)], 'state_def', 'weights_def','state_sim','levset_sim','lset')
        clear all
    end
    disp('done deform pfmt')

    T = 9, totitern = 50
    for itern = 1: totitern
        load(['../deformstats/tmp_gendata_change_iter',num2str(itern)])
        translate = 1; tdim = 6; deform = 0;  %parameters to select to run affine pf-mt
        mcpf2_geom                            % runs either deform or affine pf-mt
        state_aff = stateIS; weights_aff = prodweightold;
        save(['../deformstats/tmp_aff_change_iter',num2str(itern)], 'state_aff', 'weights_aff')
        clear all, 
        T = 9, totitern = 50
    end
    %     clear atbndrym, clear zerolengthm, clear deformindxmt, clear useKtsim
    %     clear atbndry
    %     clear levset, clear state, clear atbndrym, clear changetopom, clear zerolengthm, clear stateIS, clear levsetIS
    %     clear levset2, clear state2
    
else % display tracked data
    
    % display deform pf-mt tracking
    for itern = 1 : totitern
        load(['../deformstats/tmp_def_change_iter',num2str(itern)])
        m=1;
        for t = 1:T
            state = squeeze(state_def(:,m,t)); weight = squeeze(weights_def(:,m,t));
%             [vl,sortindx] = sort(weights_def(:,m,t));
%             % mxindx = sortindx(end);
%             %           [C,knotloc_moved,Cvel_basis] = getstate(state_def(mxindx,m,t));
%             %           [levset] = define_lset_only(C,lset);
%             %           [normalizeddist2,curvedist2] = set_symmetric_dist(levset,levset_sim(t).lset);
%             mindist2=inf;
%             for ct = 3:-1:0
%                 indx = sortindx(end-ct);
%                 [C,knotloc_moved,Cvel_basis] = getstate(state_def(indx,m,t));
%                 [levset] = define_lset_only(C,lset);
%                 [normalizeddist2,curvedist2] = set_symmetric_dist(levset,levset_sim(t).lset);
%                 mindist2 = min(mindist2,curvedist2);
%             end
%             mindist2_def(itern,t) = mindist2;
%             dist2_def(itern,t) = curvedist2;
%             normdist2_def(itern,t) = normalizeddist2;
%                        
            [Cmean,Ccx_unif,Ccy_unif] = mean_contour(state,weight); %Cmean = min(Cmean,size(lset,1)); Cmean = max(Cmean,0);
            [levset] = define_lset_only(Cmean,lset);
            [normalizeddist2,curvedist2] = set_symmetric_dist(levset,levset_sim(t).lset);
            meanCdist2_def(itern,t) = curvedist2;
            meanC_Edist_def(itern,t) = norm( state_sim(t).C - mean_contour(state,weight,length(state_sim(t).C)) );
        end
    end
    
   % display affine pf-mt tracking
    for itern = 1 : totitern
        load(['../deformstats/aff_change_iter',num2str(itern)])
        for t = 1:T
            state = squeeze(state_aff(:,m,t)); weight = squeeze(weights_aff(:,m,t));
%             [vl,sortindx] = sort(weights_aff(:,m,t));
%             mindist2=inf;
%             for ct = 3:-1:0
%                 indx = sortindx(end-ct);
%                 [C,knotloc_moved,Cvel_basis] = getstate(state_def(indx,m,t));
%                 [levset] = define_lset_only(C,lset);
%                 [normalizeddist2,curvedist2] = set_symmetric_dist(levset,levset_sim(t).lset);
%                 mindist2 = min(mindist2,curvedist2);
%             end
%             mindist2_aff(itern,t) = mindist2;
%             %mxindx = sortindx(end);
%             %[C,knotloc_moved,Cvel_basis] = getstate(state_aff(mxindx,m,t));
%             %[levset] = define_lset_only(C,lset);
%             %[normalizeddist2,curvedist2] = set_symmetric_dist(levset,levset_sim(t).lset);
%             dist2_aff(itern,t) = curvedist2;
%             normdist2_aff(itern,t) = normalizeddist2;
% 
            [Cmean,Ccx_unif,Ccy_unif] = mean_contour(state,weight); %Cmean = min(Cmean,size(lset,1)); Cmean = max(Cmean,0+6);
            [levset] = define_lset_only(Cmean,lset);
            [normalizeddist2,curvedist2] = set_symmetric_dist(levset,levset_sim(t).lset);
            meanCdist2_aff(itern,t) = curvedist2;
            meanC_Edist_aff(itern,t) = norm( state_sim(t).C - mean_contour(state,weight,length(state_sim(t).C)) );
        end
    end
    set(0,'defaultaxesfontsize',13)      
    figure(2), plot(sqrt(mean(dist2_def,1)),'b-o','LineWidth',2,'MarkerSize',12), hold on, 
    plot(sqrt(mean(dist2_aff,1)),'r-*','LineWidth',2,'MarkerSize',12)
    legend('Deform PF-MT (proposed)','Affine PF-MT'), xlabel('Frame'), grid minor
    figure(3), plot(sqrt(mean(mindist2_def,1)),'b-o','LineWidth',2,'MarkerSize',12), hold on, 
    plot(sqrt(mean(mindist2_aff,1)),'r-*','LineWidth',2,'MarkerSize',12)
    legend('Deform PF-MT (proposed)','Affine PF-MT'), xlabel('Frame'), grid minor
    figure(4), plot(mean(sqrt(mindist2_def),1),'b-o','LineWidth',2,'MarkerSize',12), hold on, 
    plot(mean(sqrt(mindist2_aff),1),'r-*')
    legend('Deform PF-MT (proposed)','Affine PF-MT'), xlabel('Frame'), grid minor
    figure(5), plot(sqrt(mean(meanCdist2_def,1)),'b-o','LineWidth',2,'MarkerSize',12), hold on, 
    plot(sqrt(mean(meanCdist2_aff,1)),'r-*','LineWidth',2,'MarkerSize',12)
    legend('Deform PF-MT (proposed)','Affine PF-MT'), xlabel('Frame'), grid minor
    
    figure(6), plot((mean(meanC_Edist_def,1)),'b-o','LineWidth',2,'MarkerSize',12), hold on, 
    plot((mean(meanC_Edist_aff,1)),'r-*','LineWidth',2,'MarkerSize',12)
    legend('Deform PF-MT (proposed)','Affine PF-MT'), xlabel('Frame'), grid minor

end
